Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms
Imports System.IO
Imports ColorCode
Imports SelectPdf

Namespace SelectPdf.Samples
    Partial Public Class PageNumbering
        Inherits Form

        Private Sub BtnCreatePdf_Click(sender As Object, e As EventArgs) _
            Handles BtnCreatePdf.Click
            Cursor = Cursors.WaitCursor
            Dim file As String = "Document.pdf"

            Try
                ' create a new pdf document
                Dim doc As New PdfDocument()
                doc.Margins = New PdfMargins(10, 10, 0, 0)

                ' create a new pdf font
                Dim font As PdfFont = doc.AddFont(PdfStandardFont.Helvetica)
                font.Size = 24

                ' add a new page to the document
                Dim page As PdfPage = doc.AddPage()

                ' footer template (100 points in height) with text element
                doc.Footer = doc.AddTemplate( _
                    doc.Pages(0).ClientRectangle.Width, 100)
                Dim text1 As New PdfTextElement(0, 50, _
                                                "Page: {page_number} of {total_pages}.", font)
                text1.ForeColor = System.Drawing.Color.Blue
                doc.Footer.Add(text1)

                ' create a new text element and add it to the page
                ' if page elements are added after header and footer is set, 
                ' they will not be displayed in those areas.
                Dim text As New PdfTextElement(0, 0, Helper.SomeLongText(), font)
                page.Add(text)

                ' save pdf document
                doc.Save(file)

                ' close pdf document
                doc.Close()
            Catch ex As Exception
                MessageBox.Show([String].Format("Error: {0}", ex.Message), "Error", _
                                MessageBoxButtons.OK, MessageBoxIcon.[Error])
                Return
            Finally
                Cursor = Cursors.Arrow
            End Try

            ' open generated pdf
            Try
                System.Diagnostics.Process.Start(file)
            Catch
                MessageBox.Show("Could not open generated pdf document", "Error", _
                                MessageBoxButtons.OK, MessageBoxIcon.[Error])
            End Try
        End Sub

        Public Sub New()
            InitializeComponent()
            Try
                ' display highlighted sample code
                Dim code As String = Helper.ReadSourceCode("PageNumbering.vb")
                WBSampleCode.DocumentText = New CodeColorizer().Colorize(code, Languages.VbDotNet)
            Catch
                WBSampleCode.DocumentText = "Sample code not available"
            End Try
        End Sub

    End Class
End Namespace
